/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime;


public class JascoDirectCallbackMethod extends JascoMethod {
	
	private JAsCoBeanCallbackMethod dcallback;
	
	public JascoDirectCallbackMethod()  {
	}
	
	public JascoDirectCallbackMethod(String aName)  
	{
		super(aName);	
	}
	
	
	
	public JascoDirectCallbackMethod(String fullname, String aName, String aClassName, int methodid, JAsCoBeanCallbackMethod callbackObject, int modifiers)  
	{
		super(fullname, aName, aClassName, methodid, callbackObject, modifiers);
		
		dcallback=callbackObject;
	}
	
	public JascoDirectCallbackMethod(String fullname, String aName, String aClassName, int methodid, JAsCoBeanCallbackMethod callbackObject, int modifiers, boolean isExecution)  
	{
		super(fullname, aName, aClassName, methodid, callbackObject, modifiers, isExecution);
		
		dcallback=callbackObject;
	}
	
	public Object invokeOriginalJAsCoMethod() throws Exception
	{	
	
		return dcallback.dispatch();
	}
	
	public Object[] getArgumentsArray()  {
		
		return dcallback.getArgumentsArray();
	}
	
	public Object getCalledObject()  {
	
		return dcallback.getCalledObject();
	}
}