/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 29-nov-2004
 */
package jasco.runtime;

import jasco.util.logging.Logger;

/**
 * @author Wim
 */
public class ReflectJascoMethod extends JascoMethod {
	
	private java.lang.reflect.Method callbackMethod = null;
	
	
	public ReflectJascoMethod(String fullname, 
			String aName, String aClassName, int methodid,
			JAsCoBeanCallback callbackObject, int modifiers, boolean isExecution) {
		super(fullname, aName, aClassName, methodid,
				callbackObject, modifiers, isExecution);
		
	}
	
	protected void initCallbackMethod() {
		
		try {
		
			Class clz = loadClass(this.getClassName());
			String res = this.getClassName();
			int index = res.lastIndexOf('.');
			res=res.substring(index+1); 
			
			callbackMethod=clz.getMethod(this.getName(), getFormalArgumentTypes());
			callbackMethod.setAccessible(true);
			}catch(Exception ex) {
	 			Logger.getInstance().showError(ex);
			}
	}
	
	public Object invokeOriginalJAsCoMethod() throws Exception
	{	
		if(callbackMethod==null)
			initCallbackMethod();
		
		return callbackMethod.invoke(this.getCalledObject(),this.getArgumentsArray());
	}
	

}
