/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime.aspect;
import jasco.runtime.JascoMethod;

public interface Cutpoint 
{	
	public static final String BEFORE = "before";
	public static final String AFTER = "after";
	public static final String REPLACE= "around";
	public static final String AFTER_THROWING="after_throwing";
	public static final String AFTER_RETURNING="after_returning";
	public static final String AROUND_THROWING="around_throwing";
	public static final String AROUND_RETURNING="around_returning";
	public static final String IS_APPLICABLE="isApplicable";
	
	
	public abstract HookContextProperty _Jasco_getHookContextPropertyForAdvice(String advice);
	public abstract PCutpointConstructorApplicationDesignator _Jasco_getConstructorRep()  ;
	public abstract String _Jasco_getCutpointName();	
	public abstract jasco.runtime.connector.Connector _Jasco_getConnector();
	
	public abstract void before(JascoMethod jp,Object jpObject,Object[] args) throws Exception;
	public abstract void after(JascoMethod jp,Object jpObject,Object[] args) throws Exception;
	public abstract void after_throwing(Object t,JascoMethod jp,Object jpObject,Object[] args) throws Exception;
	public abstract void after_returning(Object t,JascoMethod jp,Object jpObject,Object[] args) throws Exception;
	public abstract Object around_throwing(Object t,JascoMethod jp,Object jpObject,Object[] args) throws Exception;
	public abstract Object around_returning(Object t,JascoMethod jp,Object jpObject,Object[] args) throws Exception;
	public abstract Object around(JascoMethod jp,Object jpObject,Object[] args) throws Exception;
	public abstract boolean isApplicable(JascoMethod jp,Object jpObject,Object[] args);
	
	public Object proceed(JascoMethod m) throws java.lang.Exception;
	
	public abstract void globalPropertyChangeEvent(HookPropertyChangeEvent event);
	

	
}