/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 7-nov-2004
 */
package jasco.runtime.aspect;

import jasco.runtime.RuntimeContext;
import jasco.runtime.connector.MethodSignature;

import java.util.Hashtable;

/**
 * @author Wim
 */
public class PCutpointConstructorCall extends
		PCutpointConstructorApplicationDesignator {

	private String method;
		
	public PCutpointConstructorCall(String method)  {
	
		super(null);
		
		this.method=method;
	}
	
	public String getCalledMethod()  {
	
		return method;
	}
	
	public boolean eval(RuntimeContext context, Hashtable mappings, boolean forJutta)  {
		
		boolean res=true;
		
		MethodSignature sig = null;
		
		sig = (MethodSignature) mappings.get(method);	
		try {
		if(sig==null)
			res=false;
		else  {
			res= sig.matchesJoinpoint(context.getJP())&&context.isCall();
		}
		}
		catch(Exception ex)  {
			jasco.util.logging.Logger.getInstance().showError(ex.getMessage());
			ex.printStackTrace();
		}
		
		return res;
		
	}
	
	public String generateCreateCode(String argname)  {
		
		String code =argname+" = new PCutpointConstructorCall(\""+method+"\");"+NEWLINE;
		return code;
	}
	
	public String toDescString()  {
	
		return "call("+getNextArgName()+")";
	}

}


