/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime.aspect;

import jasco.runtime.RuntimeContext;
import jasco.runtime.connector.MethodSignature;

public class PCutpointConstructorCflow extends PCutpointConstructorApplicationDesignator
{		
	private String context;
	
	
	public PCutpointConstructorCflow(String param)  {
	
		super(null);
		
		
		this.context=param;
	}
	
	public boolean eval(RuntimeContext runtimeContext, java.util.Hashtable mappings, boolean forJutta)  {
	
		boolean res=true;
		
		if(forJutta)
			return true;
		
		MethodSignature m = (MethodSignature) mappings.get(context);
	//	System.out.println("m"+m.toString());
		try {
		if(m==null)
			res=false;
		else res= runtimeContext.containsMethodName(m);
		}
		catch(Exception ex)  {
			System.err.println(ex.getMessage());
			ex.printStackTrace();
		}
	//	System.out.println(res);
		return res;
	}
	
	public String generateCreateCode(String argname)  {
		
		String code =argname+" = new PCutpointConstructorCflow(\""+context+"\");"+NEWLINE;
		return code;
	}
	
	public String toDescString()  {
	
		return "cflow("+getNextArgName()+")";
	}
	
	public boolean doNotCache()  {
	
		return true;
	}
	
	
		
}