/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime.aspect;

import jasco.runtime.RuntimeContext;

public class PCutpointConstructorNot extends PCutpointConstructorApplicationDesignator
{		
	public PCutpointConstructorNot(PCutpointConstructorApplicationDesignator param1)  {
	
		super(param1);
	}
	
	public boolean eval(RuntimeContext context, java.util.Hashtable mappings, boolean forJutta)  {
		
		//when jutta is on and as a consequence result is evaluated carefully to true, resulting outcome also has to be trues
		if(forJutta)
			return true;
		
		boolean res = getParameter().eval(context,mappings,forJutta);
	
		return !res;
	}
	
	public String generateCreateCode(String argname)  {
		
		String argname1 = getNextArgName();
		
		
		String code = "";
		code+="PCutpointConstructorApplicationDesignator "+argname1+";"+NEWLINE;
		code+=getParameter().generateCreateCode(argname1);
		
		
		
		code+=""+argname+" = new PCutpointConstructorNot("+argname1+");"+NEWLINE;
		return code;
	}
	
	public String toDescString()  {
	
		return "!"+getParameter().toDescString();
	}
}