/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 12-nov-2004
 */
package jasco.runtime.aspect;

import jasco.runtime.RuntimeContext;

import java.util.Hashtable;
import java.util.Vector;

/**
 * @author Wim
 */
public class PCutpointConstructorStrict extends PCutpointConstructorRegular {
	
	private PCutpointConstructorApplicationDesignator strictSet;
	public static final String COMPLEMENT = "complement";
	private String currentStateId = "";
	
	public PCutpointConstructorStrict(PCutpointConstructorApplicationDesignator strictSet) {
		super();
		
		this.strictSet=strictSet;
	}
	
	public Vector allPointcuts() {
		
		Vector v = super.allPointcuts();
		v.add(strictSet);
		return v;
	}
	
	public String generateClassCreateCode(String argname) {
		
		String code = "";
		String param = getNextArgName();
		code+="PCutpointConstructorApplicationDesignator "+param+" = null;"+NEWLINE;
		
		String complementCode = strictSet.generateCreateCode(param);
		code+=complementCode;
		
		code+=argname+"= new PCutpointConstructorStrict("+param+");"+NEWLINE;
		 
		return code;
	}
	
	public boolean eval(RuntimeContext context,Hashtable mappings,boolean forJutta)  {
		
		boolean regEval = super.eval(context,mappings,forJutta);
		
		if(!regEval) {
			boolean contextEval = strictSet.eval(context,mappings,forJutta);
			if(!forJutta) {
				super.setStartState(super.getStartState()); //set the state to the start state again... (protocol failed...)
				currentStateId=super.getCurrentStateID();
			}
			if(forJutta&&contextEval) 
				return true; //makes sure that next time this is executed as well...
			else return false;
		}
		else {
			if(!forJutta) 
				currentStateId=super.getCurrentStateID();
			return true;
		}
	}
	
	public String getCurrentStateID() {
		
		return currentStateId;
	}

}
