/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime.connector;

import jasco.runtime.JascoMethod;
import jasco.runtime.RuntimeContext;
import jasco.runtime.aspect.HookPropertyChangeEvent;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public interface Connector
{	
	
	public Vector findCutpointForMethod(Object anInstance, RuntimeContext context, JascoMethod aJascoMethod,int startID,boolean forJutta);
	
	public Enumeration getInstances();
	public Enumeration getHooks();
	public Enumeration getMethods();
	public Enumeration getCutpoints();
	public Hashtable getMethodHashtable(int k);
	public Hashtable getMethodHashtable(CutpointElement c);
	public int indexOf(CutpointElement c);
	public Enumeration getCombinationStrategies();
	public void firePropertyChangeEvent(HookPropertyChangeEvent event);
	
	public void setEnabled(boolean b);
	public boolean isEnabled();
	
	public boolean adaptOnClasses();
	public void setAdaptOnClasses(boolean bol);
	
	public void addInstance(Object o);
	public void removeInstance(Object o);
	
	//do not use these: 
	public void setAdaptOnClassesImpl(boolean bol);
	public void setEnabledImpl(boolean b);
	
	public String getName();
	
	public String getFilename();
	public void setFilename(String s);
	
	public boolean doNotCache();
	public void setDoNotCache(boolean b);
	
	public int getPriority();
	public void setPriority(int i);
	
	
	
}