/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 8-nov-2004
 */
package jasco.runtime.hotswap;

import jasco.runtime.aspect.Cutpoint;
import jasco.util.RegexpMatcher;

/**
 * @author Wim
 *
 * TODO when call is not first ERRROR!!!!!!!!!!
 */
public class CallJoinpoint {

	private String methodname;
	private String className;
	private Cutpoint hook;
	
	public CallJoinpoint(String methodname, String classname, Cutpoint hook) {
		this.methodname=methodname;
		this.className=classname;
		this.hook=hook;
	}

	/**
	 * @return Returns the className.
	 */
	public String getClassName() {
		return className;
	}
	/**
	 * @return Returns the hook.
	 */
	public Cutpoint getHook() {
		return hook;
	}
	/**
	 * @return Returns the methodname.
	 */
	public String getMethodname() {
		return methodname; 
	}
	
	public boolean isMatch(javassist.CtMethod method) {
		
		if(method.getDeclaringClass().getName().equals(getClassName())&&RegexpMatcher.match(getMethodname(),method.getName()))
			return true;
		else return false;
	}
}
