/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 11-feb-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.inline;

import jasco.runtime.CRChangeEvent;
import jasco.runtime.ConnectorRegistry;
import jasco.runtime.ConnectorRegistryListener;
import jasco.runtime.JascoMethod;
import jasco.runtime.aspect.Cutpoint;
import jasco.runtime.hotswap.JAsCoClassLoader;
import jasco.util.logging.Logger;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;

import javassist.CtClass;
import javassist.CtMethod;

/**
 * @author Wim
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class InlineCodeCache {
	
	private static final Iterator EMPTY_ITERATOR = new Vector().iterator();
	public static final String NOSTATE = "NOSTATE";
	
	private static InlineCodeCache cache = new InlineCodeCache();
	
	private Map inlineCodeCache = new HashMap();
	private Map inlineHookJPCache = new HashMap();
	
	/**
	 * 
	 */
	private InlineCodeCache() {
		super(); 
		
		ConnectorRegistry.addConnectorRegistryListener(new ConnectorRegistryListener() {
			
			public void registryUpdated() {}
			public void registryChanged(CRChangeEvent event) {
				invalidateCache();
			}
			
		});
	}
	
	public static InlineCodeCache getInstance() {
		
		return cache;
	}
	
	
	public void invalidateCache() {
		
		inlineCodeCache.clear();
		inlineHookJPCache.clear();
	}
	
	public void addInlineCode(CtMethod jp, Object code) {
		
		inlineCodeCache.put(jp,code);
	}
	
	public Object getCachedInlineCode(CtMethod jp) {
		
		return inlineCodeCache.get(jp);
	}
	
	protected CtMethod transformToJavassistMethod(JascoMethod method) throws Exception {
		
		CtClass clz = JAsCoClassLoader.getSingleton().loadClass(method.getClassName());
		
		
		Class[] clzs = method.getFormalArgumentTypes();
		CtClass[] params = new CtClass[clzs.length];
		for(int i=0;i<clzs.length;++i)
			params[i]=JAsCoClassLoader.getSingleton().loadClass(clzs[i].getName());
		
		return clz.getDeclaredMethod(method.getName(),params);
	}
	
	public void addInlineHookJP(Cutpoint hook, String designator, JascoMethod method) {
		
		try {
		CtMethod jp = transformToJavassistMethod(method);
		
		Map res = (Map) inlineHookJPCache.get(hook);
		if(res==null) {
			res=new HashMap();
			inlineHookJPCache.put(hook,res);
		}
		
		Vector jps = (Vector) res.get(designator);
		if(jps==null) {
			jps=new Vector();
			res.put(designator,jps);
		}
		if(!jps.contains(jp))
		jps.add(jp);
		}
		catch(Exception ex) {
			Logger.getInstance().showError(ex);
		}
	}
	
	public Iterator getInlineHookJPs(Cutpoint hook, String designator) {
		
		Map res = (Map) inlineHookJPCache.get(hook);
		if(res==null) {
			return EMPTY_ITERATOR;
		}
		Vector v = (Vector) res.get(designator);
		if(v==null)
			return EMPTY_ITERATOR;
		else return v.iterator();
	}
}
