/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 11-feb-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.inline;

import jasco.runtime.JascoMethod;
import jasco.runtime.aspect.Cutpoint;
import jasco.runtime.aspect.PCutpointConstructorRegular;
import jasco.runtime.hotswap.JAsCoHotSwap;
import jasco.runtime.transform.JAsCoClassTransformer;
import jasco.util.logging.Logger;

import java.util.Iterator;
import java.util.Vector;

import javassist.ClassPool;
import javassist.CtClass;
import javassist.CtMethod;
import javassist.bytecode.CodeAttribute;

/**
 * @author Wim
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class JumpingAspectsWeaver {
	
	private static JumpingAspectsWeaver singleton = new JumpingAspectsWeaver();
	
	/**
	 * 
	 */
	private JumpingAspectsWeaver() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public static JumpingAspectsWeaver getInstance() {
		
		return singleton;
	}
	
	public void reweave(Cutpoint cp, JascoMethod method) {
		
		reweave(cp,method,(PCutpointConstructorRegular)cp._Jasco_getConstructorRep());
	}
	
	public void reweave(Cutpoint cp, JascoMethod method, PCutpointConstructorRegular regular)  {
		
		if(!InlineCompiler.getDefault().isJumpingAspectsEnabled())
			return;
		
		String designatorNow = regular.getCurrentStateID();
		
		InlineCodeCache inlineCache = InlineCodeCache.getInstance();
		InlineCodeCache.getInstance().addInlineHookJP(cp, designatorNow, method);
		
		Vector clazzes = new Vector();
		
		//first unweaven, otherwise newly inserted code might be unweaved...
		Iterator jps = inlineCache.getInlineHookJPs(cp,designatorNow);
		while(jps.hasNext()) {
			
			CtMethod jp = (CtMethod) jps.next();
			
			unweave(jp);
			if(!clazzes.contains(jp.getDeclaringClass()))
				clazzes.add(jp.getDeclaringClass());
		}
		
		Iterator desginators = regular.getNextStateIDs();
		while(desginators.hasNext()) {
			String desginatorNext = (String) desginators.next();
			jps = inlineCache.getInlineHookJPs(cp,desginatorNext);
			while(jps.hasNext()) {
			
				CtMethod jp = (CtMethod) jps.next();
				CodeAttribute code = (CodeAttribute) inlineCache.getCachedInlineCode(jp);
			
				reweave(jp,code);
				if(!clazzes.contains(jp.getDeclaringClass()))
					clazzes.add(jp.getDeclaringClass());
			}
		}
		
		CtClass[] clz = new CtClass[clazzes.size()];
		clazzes.copyInto(clz);
		
		try {
		JAsCoHotSwap.getSingleton().redefineClasses(clz);
		}catch (Exception ex) {
			Logger.getInstance().showError(ex);
		}
	}
	
	public void reweave(CtMethod jp, CodeAttribute code) {
		
		
		
		try {
			
		Logger.getInstance().showDebug("reweaving jp "+jp.getDeclaringClass().getName()+"."+jp.getName()+jp.getSignature());
		jp.getMethodInfo().setCodeAttribute(code);
		
		
		}catch (Exception ex) {
			Logger.getInstance().showError(ex);
		}
	}
	
	public void unweave(CtMethod jp) {
		
		ClassPool classPool = ClassPool.getDefault();
		
		JAsCoClassTransformer transformer = new JAsCoClassTransformer(jp.getDeclaringClass());
		
		Vector v = new Vector();
		v.add(jp);
		
		Vector clazz = new Vector();
		clazz.add(jp.getDeclaringClass());
		
		try {
		Logger.getInstance().showDebug("unweaving jp "+jp.getDeclaringClass().getName()+"."+jp.getName()+jp.getSignature());
		transformer.removeTrapsAtRuntimeByConcreteMethods(v);
		}catch (Exception ex) {
			Logger.getInstance().showError(ex);
		}
	}

}
