/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.ant;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
import jasco.Jasco;
import jasco.options.Options;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.types.Reference;

// The ant task for the compiling connectors
public class JAsCoConnectorCompilerTask extends Task {
	
	private String destination = null;
	private String input = null;
	private String classpath = "";
	
	 // The method executing the task
	public void execute() throws BuildException {
		try {
			Options.setClassLoader(this.getClass().getClassLoader());
			Jasco.setOutputDir(destination);
			Jasco.compileConnector(input);
		}
		catch(Throwable e) {
			System.out.println(e);
			e.printStackTrace();
		}
	}
		  
	// The setter for the destination attribute
	public void setDestination(String aDestination) {
		destination = aDestination;
	}

	// The sette for the input attribute
	public void setInput(String aInput) {
		input = aInput;
	}
	
	// Set the classpath ref
    public void setClasspathRef(Reference aPath) {
    	Path path = new Path(getProject());
		path.setRefid(aPath);
		String[] paths = path.list();
		for (int i = 0 ; i < paths.length ; i++) {
			Options.addSinglePathToClassPath(paths[i]);
		}
    }
	
	// The setter for the classpath
	public void setClasspath(String aPath) {
		Options.addSinglePathToClassPath(aPath);
	}

}
