/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.aspectparser;

import jasco.tools.jascoparser.PImport;
import jasco.tools.jascoparser.PImports;
import jasco.tools.jascoparser.PJavaClass;
import jasco.tools.jascoparser.PJavaCode;
import jasco.tools.jascoparser.PJavaCodes;

public class PAspect extends PJavaClass
{
	private PImports imports = new PImports();
	private PCutpoints cutpoints = new PCutpoints();
	private PJavaCodes aspectcode = new PJavaCodes();
	private PPackage packagename = new PPackage("",0);
	
	PAspect() 
	{
	}
	
	public void setPackage(PPackage aPackage)  
	{
		packagename = aPackage;  	
	}
	
	public PPackage getPackage()  {
	
		return packagename;
	}
	
	public void setAspectName(String aAspectName) 
	{
		setName(aAspectName);
	}
	
	public void setImports(PImports p) {
		imports=p;
	}
	
	public String getAspectName() 
	{
		return getName();
	}
	
	public void setExtendingAspectName(String aAspectName) 
	{
		setSuperClass(aAspectName);
	}
	
	public String getExtendingAspectName() 
	{
		return getSuperClassSimple();
	}
	
	public void addImport(PImport aImport)
	{
		imports.addImport(aImport);
	}
	
	public PImports getImports() 
	{
		return imports;
	}
	
	public void addAspectJavaCode(PJavaCode aJavaCode)
	{
		aspectcode.addJavaCode(aJavaCode);
	}
	
	public PJavaCodes getAspectJavaCode()
	{
		return aspectcode;
	}
	
	public void addCutpoint(PCutpoint aCutpoint)
	{
		cutpoints.addCutpoint(aCutpoint);
	}
	
	public PCutpoints getCutpoints()
	{
		return cutpoints;
	}
	
	public void outprint() 
	{
		/*System.out.println("Aspect with name: " +  getAspectName() + " extending " + getExtendingAspectName());
		System.out.println("");
		System.out.println("");
		
		System.out.println("With following global Java code: ");
		for (int i = 0 ; i < globaljavacode.getJavaCodeSize() ; i ++) 
		{
			System.out.println(globaljavacode.getJavaCode(i));
			System.out.println("");
		}
		System.out.println("");
		
		System.out.println("With following cutpoints: ");
		System.out.println("");
		System.out.println("");
		for (int i = 0 ; i < (cutpoints.getCutpointsSize()) ; i++)
		{
			PCutpoint t = cutpoints.getCutpoint(i);
			System.out.println("	Cutpoint with name: " +  t.getCutpointName() + " extending " + t.getExtendingCutpointName());
			System.out.println("");
			PCutpointConstructor con =  t.getCutpointConstructor();
			PCutpointConstructorMethod met = con.getCutpointConstructorMethod();
			System.out.println("	With Constructor: with methodname: " + met.getCutpointConstructorMethodName());
			
			for (int b = 0 ; b < met.getArgumentsSize(); b++) 
			{ 
				System.out.println(met.getArgumentName(b) + " " + met.getArgumentType(b));
			}
			
			System.out.println(con.getConstructorBody());
			
			System.out.println("");
			
			if (t.getBeforeCutpointAdaptation() != null) 
			{
				System.out.println("	With before adaptation: " + (t.getBeforeCutpointAdaptation()).getCutpointAdaptationImplementation());
				System.out.println("");
			}
			if (t.getAfterCutpointAdaptation() != null) 
			{
				System.out.println("	With after adaptation: " + (t.getAfterCutpointAdaptation()).getCutpointAdaptationImplementation());
				System.out.println("");
			}
			if (t.getReplaceCutpointAdaptation() != null) 
			{
				System.out.println("	With replace adaptation: " + (t.getReplaceCutpointAdaptation()).getCutpointAdaptationImplementation());
				System.out.println("");
			}
			
			System.out.println("	With following local Java code: ");
			for (int j = 0 ; j < (t.getLocalJavaCode()).getJavaCodeSize() ; j++) 
			{
				System.out.println("	" + (t.getLocalJavaCode()).getJavaCode(j));
				System.out.println("");
			}
			
			System.out.println("	With following abstract Java code: ");
			for (int j = 0 ; j < (t.getAbstractJavaCode()).getJavaCodeSize() ; j++) 
			{
				System.out.println("	" + (t.getAbstractJavaCode()).getJavaCode(j));
				System.out.println("");
			}
			System.out.println("");
		}*/
	}
				
	
}
	
	
	
		
	