/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.aspectparser;

import jasco.runtime.aspect.Cutpoint;
import jasco.tools.jascoparser.PJavaCode;
import jasco.tools.jascoparser.PJAsCoParseElement;


public class PCutpointAdaptation extends PJAsCoParseElement
{
	//adapted so that linenumbers with docu can be inserted for error-checks
	//private String adaptation = "";
	private PJavaCode adaptation = null;
	private String name = null;
	private String type = null;
	private String argname = null;
	
	public static final String BEFORE = Cutpoint.BEFORE;
	public static final String AFTER = Cutpoint.AFTER;
	public static final String REPLACE = Cutpoint.REPLACE;
	public static final String AFTER_THROWING = Cutpoint.AFTER_THROWING;
	public static final String AFTER_RETURNING = Cutpoint.AFTER_RETURNING;
	public static final String AROUND_THROWING = Cutpoint.AROUND_THROWING;
	public static final String AROUND_RETURNING = Cutpoint.AROUND_RETURNING;
	
	
	PCutpointAdaptation(int lineno)
	{
		super(lineno);
	}
	
	public String getArgName()  {
		return argname;
	}
	
	public void setArgName(String m)  {
	
		argname=m;
	}
	
	public void setType(String type)  {
		this.type=type;
	}
	
	public String getType()  {
	
		return type;
	}
	
	public boolean hasName()  {
	
		return name!=null;
	}
	
	public String getName()  {
	
		return name;
	}
	
	public void setName(String name)  {
	
		this.name=name;
	}
	
	public void setCutpointAdaptationImplementation(PJavaCode aAdaptation)
	{
		adaptation = aAdaptation;
	}
	
	public PJavaCode getCutpointAdaptationImplementation()
	{
		return adaptation;
	}
	
	public String getReturnType()  {
	
		if(type.equals(REPLACE)||type.equals(AROUND_RETURNING)||type.equals(AROUND_THROWING))
			return "Object";
		else return "void"	;
	}
	
	public boolean hasReturnType()  {
	
		return !getReturnType().equals("void");
	}
	
	public boolean throwsException()  {
	
		return true;
	}
}