/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.aspectparser;
import jasco.tools.jascoparser.PJAsCoParseElement;

import java.util.Iterator;
import java.util.Vector;

public class PCutpointConstructorMethod extends PJAsCoParseElement
{
	private String methodname = null;
	private Vector argumentnames = new Vector();
	private Vector argumenttypes = new Vector();
	private String constructorbody = null;
	private String returnType = "";
	
	PCutpointConstructorMethod() 
	{
	}
	
	public String getCutpointConstructorMethodName() 
	{
		return methodname;
	}
	
	public Iterator getArgumentNames() {
		
		return argumentnames.iterator();
	}
	
	public void setCutpointConstructorMethodName(String aMethodName) 
	{
		methodname = aMethodName;
	}
	
	public String getType(String aName)  {
	
		int i = argumentnames.indexOf(aName);
		if(i!=-1)
			return (String) argumenttypes.elementAt(i);
		else return null;
	}
	
	public boolean hasReturnType()  {
	
		return !returnType.equals("");
	}	
		
	
	public void addArgument(String aName, String aType) 
	{
		argumentnames.add(aName);
		argumenttypes.add(aType);
	}
	
	public Iterator getArgumentTypes()  {
	
		return argumenttypes.iterator();
	}
	
	public String getArgumentName(int aPlace)
	{
		return (String)argumentnames.elementAt(aPlace);
	}
	
	public String getArgumentType(int aPlace)
	{
		return (String)argumenttypes.elementAt(aPlace);
	}
	
	public int getArgumentsSize() 
	{
		return argumentnames.size();
	}
	
	public int getNumberTag(String arg)  {
	
		return argumentnames.indexOf(arg);
	}
	public String getReturnType()  {
	
		return returnType;
	}
	public void setReturnType(String type)  {
	
		returnType=type;
	}
}