/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.connectorparser;

import jasco.runtime.connector.CombinationStrategy;
import jasco.tools.jascoparser.PImport;
import jasco.tools.jascoparser.PImports;
import jasco.tools.jascoparser.PJavaCode;
import jasco.tools.jascoparser.PJavaCodes;

import java.util.Iterator;
import java.util.Vector;

public class PConnector {

	private String connectorname = null;
	private String extendingconnectorname = null;
	private String packagename = null;
	private PImports imports = new PImports();
	private PCutpointDeclarations cutpointdeclarations = new PCutpointDeclarations();
	private int priority = 0;
	private Vector annotations = new Vector();
	private PCutpointExecutions cutpointexecutions = new PCutpointExecutions();
	private PJavaCode globaljavacode = new PJavaCode();
	private boolean staticConnector = true;
	private Vector cutpointmethodexecutions = new Vector();
	private Vector combStrats = new Vector();
	private PJavaCodes javacode = new PJavaCodes();

	PConnector() {
	}
	
	public void setPriority(int i) {
		
		priority=i;
	}
	
	public int getPriority() {
		return priority;
	}
	
	public void addAnnotation(String a) {
		
		annotations.add(a);
	}
	
	public Iterator getAnnotations() {
		
		return annotations.iterator();
	}
	
	public void addCombinationStrategy(CombinationStrategy s)  {
	
		combStrats.add(s);
	}
	public Iterator getCombinationStrategys()  {
	
		return combStrats.iterator();
	}
	
	public void addCutpointMethodExecution(String aExecution) { 
		cutpointmethodexecutions.add(aExecution); 
	} 

	public Vector getCutpointMethodExecutions() { 
		return cutpointmethodexecutions; 
	}

	public void setConnectorName(String aConnectorName) {
		connectorname = aConnectorName;
	}

	public void setStaticConnector(boolean bol) {

		staticConnector=bol;
	}

	public boolean isStaticConnector() {

		return staticConnector;
	}

	public String getConnectorName() {
		return connectorname;
	}

	public void setExtendingConnectorName(String aConnectorName) {
		extendingconnectorname = aConnectorName;
	}

	public String getExtendingConnectorName() {
		return extendingconnectorname;
	}

	public void setPackageName(String aPackageName) {
		packagename = aPackageName;
	}

	public String getPackageName() {
		return packagename;
	}

	public void addImport(PImport aImport) {
		imports.addImport(aImport);
	}

	public PImports getImports() {
		return imports;
	}
	
	public void setImports(PImports p) {
		imports=p;
	}

	public void addCutpointDeclaration(PCutpointDeclaration aCutpointDeclaration) {
		cutpointdeclarations.addCutpointDeclaration(aCutpointDeclaration);
	}
	
	
	public PCutpointDeclarations getCutpointDeclarations() {
		return cutpointdeclarations;
	}

	public void addCutpointExecution(PCutpointExecution aCutpointExecution) {
		cutpointexecutions.addCutpointExecution(aCutpointExecution);
	}

	public PCutpointExecutions getCutpointExecutions() {
		return cutpointexecutions;
	}
	
	public void outprint() {
	
	}
	
	public void addJavaCode(PJavaCode aJavaCode) 
     { 
          javacode.addJavaCode(aJavaCode); 
     } 
      
     public PJavaCodes getAspectJavaCode() 
     { 
          return javacode; 
     }
	
	
	

}
