/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.gui;


public class JascoIntrospector {
	
	
	public static void main(String[] args) throws Exception {
	
		Runtime.getRuntime().traceInstructions(true);
		
		new ConnectorRegistryIntrospector();
		
		
		
		
	}
	
	public static boolean displayStackTraceInformation (Throwable ex,
                                                        boolean displayAll)
        {
        if (null == ex)
            {
            System.out.println ("Null stack trace reference! Bailing...");
            return false;
            }

        System.out.println ("The stack according to printStackTrace():\n");
        ex.printStackTrace();
        System.out.println ("");

        StackTraceElement[] stackElements = ex.getStackTrace();

        if (displayAll)
            {
            System.out.println ("The " + stackElements.length +
                                " element" +
                                ((stackElements.length == 1) ? "": "s") +
                                " of the stack trace:\n");
            }
        else
            {
            System.out.println ("The top element of a " +
                                stackElements.length +
                                " element stack trace:\n");
            }
        
        for (int lcv = 0; lcv < stackElements.length; lcv++)
            {
            System.out.println ("Filename: " +
                                stackElements[lcv].getFileName());
            System.out.println ("Line number: " +
                                stackElements[lcv].getLineNumber());

            String className = stackElements[lcv].getClassName();
            String packageName = "todo";
            String simpleClassName = "todo";

            System.out.println ("Package name: " +
                                ("".equals (packageName)?
                                "[default package]" : packageName));
            System.out.println ("Full class name: " + className);
            System.out.println ("Simple class name: " + simpleClassName);
            System.out.println ("Unmunged class name: " +
                                "todo");
            System.out.println ("Direct class name: " +
                                "todo");

            System.out.println ("Method name: " +
                                stackElements[lcv].getMethodName());
            System.out.println ("Native method?: " +
                                stackElements[lcv].isNativeMethod());

            System.out.println ("toString(): " +
                                stackElements[lcv].toString());
            System.out.println ("");

            if (!displayAll)
                return true;
            }
        System.out.println ("");

        return true;
        }       // End of displayStackTraceInformation().

}