/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 20-okt-2004
 */
package jasco.util;

import jasco.options.Options;
import jasco.util.logging.JAsCoException;

import java.io.InputStream;

/**
 * @author Wim
 */

public class ExceptionStreamGobbler extends StreamGobbler   {
	
	String errors="";
	
	ExceptionStreamGobbler(InputStream is, String type, boolean typed) {
	super(is,type,typed);
	}

	ExceptionStreamGobbler(InputStream is, String type) {
		super(is,type);
	}
	
	public  void showOutput(String s)  {
	
		System.out.println(s);
	}
	public  void showError(String s)  {
	
		errors+=s+Options.NEWLINE;
	}
	public  void flush()  {
	
		if(!errors.equals(""))
			throw new JAsCoException(errors);
	}
}

