/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.gui;

import jasco.options.Options;
import jasco.util.AbstractDialog;
import jasco.util.BrowseField;
import jasco.util.MyFileChooser;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class TransformBeanDialog extends AbstractDialog {
	
	private String currentClass="";
	private MyFileChooser fileChooser;
	private BrowseField browser;
	
	public TransformBeanDialog(JFrame parent)  {
	
		super(parent, "Tranform a JAVA bean", 100, 100);
		
		JPanel content = new JPanel();
		content.setLayout(new GridLayout(3,2,20,20));
		
		JLabel selectFile = new JLabel("Specify the bean to transform: ");
		JLabel resultClassLabel =new JLabel("Selected java bean: ");
		
		final JLabel resultClass = new JLabel("none");
		fileChooser = new MyFileChooser(parent);
		fileChooser.selectDir(new File(System.getProperty("user.dir")));
		fileChooser.addChoosableFileFilter(new javax.swing.filechooser.FileFilter()  {
		
			public boolean accept(File f)  {
			
				return f.getName().endsWith(".class");
			}
				
			
			public String getDescription()  {
			
				return "*.class";
			}
		});
		final JButton okButton       = new JButton("TRANFORM");
		okButton.setEnabled(false);
		
		browser = new BrowseField(fileChooser,false);
		browser.addActionListener(new ActionListener()  {
		
			public void actionPerformed(ActionEvent ev)  {
				
				Options.setOutputDir(new File(browser.getSelectedFile()).getParent());
				String file = browser.getSelectedFile();
				
				/*
				try {
				jasco.weaver.Weaver weaver = new jasco.weaver.Weaver(new File(file));
				jasco.weaver.Class cl = weaver.getDecompiledClass();
				if (cl!=null)  {
					currentClass=cl.getClassName().replace('/','.');
					okButton.setEnabled(true);
				}
				else  {
					currentClass="";
					okButton.setEnabled(false);
				}	
				}catch(Throwable ex)  {
					currentClass="";
					okButton.setEnabled(false);
				}
				
				resultClass.setText(currentClass);
				*/
			}
		});
		
		
		JButton cancelButton   = new JButton("CANCEL");
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				dialogApproved();
			} 

		});
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				dialogCanceled();
			} 

		});
		
		content.add(selectFile);
		content.add(browser);
		content.add(resultClassLabel);
		content.add(resultClass);
		content.add(cancelButton);
		content.add(okButton);
		
		setContentPane(content);
		setResizable(true);
		pack();
		setResizable(false);
	}
	
	public void dialogApproved()  {
		
		Options.setOutputDir(new File(browser.getSelectedFile()).getParent());
		String output = Options.getOutputDir();
		int k = 0;
		int i = currentClass.indexOf(".");
		while (i>=0)  {
			File file = new File(output);
			output=file.getParent();
			if (output==null)  {
				System.err.println("error: bean not in correct classpath");
				return;
			}
			k=i+1;
			i = currentClass.indexOf(".",k);
		}
		Options.setOutputDir(output);
		jasco.Jasco.transformBeanInOutputDir(currentClass,new Vector());
		System.out.println("if the tool sais the bean is allready a jasco bean and it is not, restart the introspector to refresh loaded classes");
		setVisible(false);
	}
	
	public void dialogCanceled()  {
		setVisible(false);
	}
}
				
				
				 	
		